/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.dao.ibatis;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import jp.terasoluna.fw.dao.ibatis.QueryDAOiBatisImpl;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.ibatis.SqlMapClientTemplate;

import com.ibatis.sqlmap.client.SqlMapClient;

/**
 * {@link QueryDAOiBatisImpl}̎̂߂ɎgpX^uB
 * 
 * {@link QueryDAOiBatisImpl}̌ĂяomFpɎgpB
 * 
 */
public class QueryDAOiBatisImpl_SqlMapClientTemplateStub01 extends SqlMapClientTemplate {

    /**
     * RXgN^
     */
    public QueryDAOiBatisImpl_SqlMapClientTemplateStub01() {

        //SqlMapClient̐ݒ
        SqlMapClient sqlMapClient = new QueryDAOiBatisImpl_SqlMapClientStub01();
        setSqlMapClient(sqlMapClient);

        //f[^\[X̐ݒ
        DataSource dataSource = new QueryDAOiBatisImpl_DataSourceStub01();
        setDataSource(dataSource);
    }

    /**
     * QueryDAOiBatisImpleXgpqueryForObject\bh
     */
    @Override
    public Object queryForObject(String statementName, Object parameterObject) throws DataAccessException {
        called = true;
        this.statementName = statementName;
        this.parameterObject = parameterObject;
        return "abc";
    }

    /**
     * QueryDAOiBatisImpleXgpqueryForMap\bh
     */
    @Override
    public Map<String, Object> queryForMap(String statementName, Object parameterObject, String keyProperty) throws DataAccessException {
        called = true;
        this.statementName = statementName;
        this.parameterObject = parameterObject;
        this.keyProperty = keyProperty;
        return new HashMap<String, Object>();
    }

   /**
     * QueryDAOiBatisImpleXgpqueryForList\bh
     */
    @Override
    public List queryForList(String statementName, Object parameterObject) throws DataAccessException {
        called = true;
        this.statementName = statementName;
        this.parameterObject = parameterObject;
        List<String> list = new ArrayList<String>();
        list.add("a");
        list.add("b");
        list.add("c");
        return list;
    }

    /**
      * QueryDAOiBatisImpleXgpqueryForList\bh
      */
    @Override
    public List queryForList(String statementName, Object parameterObject, int skipResults, int maxResults) throws DataAccessException {
        called = true;
        this.statementName = statementName;
        this.parameterObject = parameterObject;
        this.skipResults = skipResults;
        this.maxResults = maxResults;
        List<String> list = new ArrayList<String>();
        list.add("a");
        list.add("b");
        list.add("c");
        return list;
    }

    /*
     * ĂяomFpϐ
     */
    private boolean called = false;
    private String statementName = null;
    private Object parameterObject = null;
    private String keyProperty = "";
    private int skipResults = 0;
    private int maxResults = 0;

    public boolean isCalled() {
        return called;
    }

    public Object getParameterObject() {
        return parameterObject;
    }

    public String getStatementName() {
        return statementName;
    }

    public String getKeyProperty() {
        return keyProperty;
    }

    public int getMaxResults() {
        return maxResults;
    }

    public int getSkipResults() {
        return skipResults;
    }

}
